/*
 *
 *  ALL03
 *
 *  26.07.2002
 *
 *  by Fabio Sturman
 *
 *  fabio.sturman@tiscali.it
 *
 *  90slv.h
 *
 *  main module include file
 *
 */

/* Copyright (c) 2002 Fabio Sturman (fabio.sturman@tiscali.it)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/*- AT90SLV Level 1 --------------------------------------*/

#define PIN_MISO_2323    22
#define PIN_NRESET_2323  17
#define PIN_SCK_2323     23
#define PIN_MOSI_2323    21
#define PIN_VCC_2323     27
#define PIN_CLOCK_2323    0

#define PIN_MISO_8515     7
#define PIN_NRESET_8515   9
#define PIN_SCK_8515      8
#define PIN_MOSI_8515     6
#define PIN_VCC_8515     40
#define PIN_CLOCK_8515   19

#define set_miso(x)     all03_wr_pin(pin_miso,x)
#define set_mosi(x)     all03_wr_pin(pin_mosi,x)
#define set_sck(x)      all03_wr_pin(pin_sck,x)
#define set_nreset(x)   all03_wr_pin(pin_nreset,x)
#define set_power()     all03_wr_vcc_pin(pin_vcc,1)
#define get_miso()      all03_rd_pin(pin_miso)

#define set_clock() all03_select_f_osc(1); all03_set_osc_18_19(1)

#define CMD_PROGRAMMING_ENABLE_1 0xac
#define CMD_PROGRAMMING_ENABLE_2 0x53

#define CMD_CHIP_ERASE_1 0xac
#define CMD_CHIP_ERASE_2 0x80

#define CMD_READ_PROGRAM_MEMORY 0x20

#define CMD_WRITE_PROGRAM_MEMORY 0x40

#define CMD_READ_EEPROM_MEMORY 0xa0

#define CMD_WRITE_EEPROM_MEMORY 0xc0

/*  no 8515 */
#define CMD_READ_LOCK_AND_FUSE_BITS 0x58

#define CMD_WRITE_LOCK_BITS_1 0xac
#define CMD_WRITE_LOCK_BITS_2 0xf9

/* only 2323 */
#define CMD_WRITE_FSTRT_BIT_1 0xac
#define CMD_WRITE_FSTRT_BIT_2 0xbe

/* only 2343 */
#define cmd_write_rcen_bit(x) cmd_write_fstrt_bit(x)

#define CMD_READ_SIGNATURE_BYTES 0x30


/*- AT90SLV Level 2 --------------------------------------*/

#define print_no_8515() printf("\n\007* ALL03 Error - not implemented for AT90S8515!\n");
#define print_chip_model() printf("Model: %s\n",chip_model)
#define PROC_STRING "\nINSERT %s on adapter %s and press <Enter>\n",chip_model,adapter_model

#define IS_AT90S8515    !strcmp(chip_model,"AT90S8515")
#define IS_AT90S_LS2323 !strcmp(chip_model,"AT90S/LS2323")
#define IS_AT90S_LS2343 !strcmp(chip_model,"AT90S/LS2343")


 /*- AT90SLV Level 1 --------------------------------------*/

/* write read */
unsigned char wr_rd_serial(unsigned char byt);
/* put chip in programming mode */
int chip_init(void);
int cmd_programming_enable(void);
void cmd_chip_erase(void);
unsigned char cmd_read_program_memory(int lohi, unsigned short int address);
void cmd_write_program_memory(int lohi, unsigned short int address, unsigned char data);
unsigned char cmd_read_eeprom_memory(unsigned short int address);
void cmd_write_eeprom_memory(unsigned short int address, unsigned char data);
unsigned char cmd_read_lock_and_fuse_bits(void);
void cmd_write_lock_bits(int lock_bit_1, int lock_bit_2);
void cmd_write_fstrt_bit(int nfstrt);
unsigned char cmd_read_signature_bytes(unsigned short int address);
int wait_rdy_program(int hilo, unsigned short int address, unsigned char data);
int wait_rdy_eeprom(unsigned short int address, unsigned char data);

/*- AT90SLV Level 2 --------------------------------------*/

void edit_chip_model(void);
void display_lock_and_fuse_bits(void);
void edit_lock_and_fuse_bits(void);
void read_lock_and_fuse_bits(void);
void write_fuse_bits(void);
void write_lock_bits(void);
void chip_erase(void);
void read_signature_bytes(void);
void write_program_memory(void);
void read_program_memory(void);
void read_eeprom_memory(void);
void blank_check_eeprom_memory(void);
void verify_eeprom_memory(void);
void write_eeprom_memory(void);
void blank_check_program_memory(void);
void verify_program_memory(void);
void read_program_memory_buffer_from_file(void);
void write_program_memory_buffer_to_file(void);
void read_eeprom_memory_buffer_from_file(void);
void write_eeprom_memory_buffer_to_file(void);
void display_help(void);
int main(int argc, char *argv[]);

