/*
 *
 *  ALL03
 *
 *  14.05.2003
 *
 *  by Fabio Sturman
 *
 *  fabio.sturman@tiscali.it
 *
 *  pic16f84.h
 *
 *  main module include file
 *
 */

/* Copyright (c) 2002, 2003 Fabio Sturman (fabio.sturman@tiscali.it)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/*- PIC16F8X Level 1 --------------------------------------*/

#define PIN_SIO_PIC16F84    24
#define PIN_NMCLR_PIC16F84  15
#define PIN_SCK_PIC16F84    23
#define PIN_VCC_PIC16F84    26

#define PIN_SIO_PIC16F877    24
#define PIN_NMCLR_PIC16F877  15
#define PIN_SCK_PIC16F877    23
#define PIN_VCC_PIC16F877    26

#define set_sio(x)      all03_wr_pin(pin_sio,x)
#define set_sck(x)      all03_wr_pin(pin_sck,x)
#define set_power()     all03_wr_vcc_pin(pin_vcc,1)
#define get_sio()       all03_rd_pin(pin_sio)


#define CMD_LOAD_CONFIGURATION             0x00
#define CMD_LOAD_DATA_FOR_PROGRAM_MEMORY   0x02
#define CMD_READ_DATA_FROM_PROGRAM_MEMORY  0x04
#define CMD_INCREMENT_ADDRESS              0x06
#define CMD_BEGIN_ERASE_PROGRAMMING_CYCLE  0x08
#define CMD_BEGIN_PROGRAMMING              0x08

// only for 16f84a/16f877 <
#define CMD_BEGIN_ERASE_ONLY_CYCLE         0x18
//                        >
#define CMD_LOAD_DATA_FOR_DATA_MEMORY      0x03
#define CMD_READ_DATA_FROM_DATA_MEMORY     0x05
#define CMD_BULK_ERASE_PROGRAM_MEMORY      0x09
#define CMD_BULK_ERASE_DATA_MEMORY         0x0b

/*- PIC16F8X Level 2 --------------------------------------*/

#define print_chip_model() printf("Model: %s\n",chip_model)
#define PROC_STRING "\nINSERT %s on adapter %s and press <Enter>\n",chip_model,adapter_model

#define IS_PIC16F84    !strcmp(chip_model,"PIC16F84")
#define IS_PIC16F83    !strcmp(chip_model,"PIC16F83")
#define IS_PIC16F877   !strcmp(chip_model,"PIC16F877")


/*- PIC16F84 Level 1 --------------------------------------*/

/* write read */
unsigned char wr_rd_serial(unsigned char byt);
/* put chip in programming mode */
int chip_init(void);

/*- PIC16F84 Level 2 --------------------------------------*/

void edit_chip_model(void);
void display_configuration_bits(void);
void edit_configuration_bits(void);
void write_configuration_bits(void);
void chip_erase(void);
void write_program_memory(int i);
void read_program_memory(void);
void read_eprom_memory(void);
void blank_check_eprom_memory(void);
void write_eprom_memory(int i);
void blank_check_program_memory(void);
void read_program_memory_buffer_from_file(void);
void write_program_memory_buffer_to_file(void);
void read_eprom_memory_buffer_from_file(void);
void write_eprom_memory_buffer_to_file(void);
void display_help(void);
int main(int argc, char *argv[]);

